# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2011 Camptocamp SA (http://www.camptocamp.com)
# All Right Reserved
#
# Author : Yannick Vaucher (Camptocamp)
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from tools.translate import _

class CRMSendEmail(osv.osv_memory):
 
    _inherit = "crm.send.mail"

    _columns = {
       'date_action': fields.date('Next Action Date'),
       'title_action': fields.char('Next Action', size=64),
    }


    def action_send(self, cr, uid, ids, context=None):
        """ Override to add write date_action and title_action """
        hist_obj = self.pool.get('mailgate.message')
        
        to_return = super(CRMSendEmail, self).action_send(cr, uid, ids, context=context)
        model = context.get('active_model')
        case_pool = self.pool.get(model) 

        res_id = context and context.get('active_id', False) or False
        for obj in self.browse(cr, uid, ids, context=context):
            if context.get('mail', 'new') not in ['new', 'forward']:
                hist = hist_obj.browse(cr, uid, res_id, context=context)
                res_id = hist.res_id
                model = hist.model
            case = case_pool.browse(cr, uid, res_id, context=context)
            if obj.date_action:
                values = {'date_action': obj.date_action}
                case_pool.write(cr, uid, [case.id], values, context=context)
            if obj.title_action:
                values = {'title_action': obj.title_action}
                case_pool.write(cr, uid, [case.id], values, context=context)

        return to_return

CRMSendEmail()
